import numpy as np
import matplotlib.pyplot as plt
import sys
a = np.loadtxt('grid1testz49_50_51_53_54_55.txt.dat')
cols = [[c[i] for c in a] for i in range(len(a[0]))]
fields = 'nodes conns branches branch V grid V spiral V lattice V linear V loop V right V random V FruchtermanReingold V seed'.split(' ')
def f(x): return fields.index(x)

b = np.array(cols[f('spiral')+1])/np.array(cols[f('lattice')+1])
#b.sort()
print('Spiral better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Spiral 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Spiral 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Spiral 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Spiral 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Spiral 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Spiral %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Spiral %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Spiral %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Spiral %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Spiral %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Spiral %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))

"""
Spiral better than Lattice 55.359%
Spiral 2x better than Lattice 25.021%
Spiral 3x better than Lattice 11.785%
Spiral 4x better than Lattice 7.451%
Spiral 5x better than Lattice 5.468%
Spiral 6x better than Lattice 4.017%
Lattice better than Spiral 44.641%
Lattice 2x better than Spiral 17.703%
Lattice 3x better than Spiral 7.451%
Lattice 4x better than Spiral 4.067%
Lattice 5x better than Spiral 2.817%
Lattice 6x better than Spiral 2.084%
"""

b = np.array(cols[f('branch')+1])/np.array(cols[f('lattice')+1])
print('Branch better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Branch 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Branch 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Branch 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Branch 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Branch 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Branch %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Branch %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Branch %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Branch %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Branch %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Branch %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))

b = np.array(cols[f('grid')+1])/np.array(cols[f('lattice')+1])
print('Grid better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Grid 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Grid 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Grid 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Grid 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Grid 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Grid %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Grid %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Grid %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Grid %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Grid %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Grid %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))

b = np.array(cols[f('loop')+1])/np.array(cols[f('lattice')+1])
print('Loop better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Loop 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Loop 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Loop 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Loop 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Loop 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Loop %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Loop %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Loop %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Loop %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Loop %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Loop %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))

b = np.array(cols[f('right')+1])/np.array(cols[f('lattice')+1])
print('Right Loop better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Right Loop 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Right Loop 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Right Loop 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Right Loop 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Right Loop 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Right Loop %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))


b = np.array(cols[f('random')+1])/np.array(cols[f('lattice')+1])
print('Random better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Random 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Random 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Random 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Random 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Random 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Random %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Random %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Random %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Random %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Random %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Random %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))

b = np.array(cols[f('FruchtermanReingold')+1])/np.array(cols[f('lattice')+1])
print('Fruchterman-Reingold better than Lattice %3.3f%%' % (100*len([x for x in b if x < 1])/len(b)))
print('Fruchterman-Reingold 2x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/2)])/len(b)))
print('Fruchterman-Reingold 3x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/3)])/len(b)))
print('Fruchterman-Reingold 4x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/4)])/len(b)))
print('Fruchterman-Reingold 5x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/5)])/len(b)))
print('Fruchterman-Reingold 6x better than Lattice %3.3f%%' % (100*len([x for x in b if x < (1/6)])/len(b)))

print('Lattice better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= 1])/len(b)))
print('Lattice 2x better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= (2)])/len(b)))
print('Lattice 3x better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= (3)])/len(b)))
print('Lattice 4x better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= (4)])/len(b)))
print('Lattice 5x better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= (5)])/len(b)))
print('Lattice 6x better than Fruchterman-Reingold %3.3f%%' % (100*len([x for x in b if x >= (6)])/len(b)))
