/*
 * Small Wide World
 * by Joel R. Voss aka. Javantea
 * Copyright 2007 AltSci Concepts
 * June 28, 2007
 *
 * Test program in C++.
 */

/*
Map maker
by Javantea
April 26, 2007
Ported to C++: June 28, 2007

*/

#include <cmath>
#include <iostream>
#include <sstream>
#include <stdlib.h>

using std::cout;
using std::cerr;
using std::endl;
using std::stringstream;

#include "sww.h"

Map createMap(int seed_id=3211)
{
	srand(seed_id);
	Map a(NULL, 640, 480, 2);
	a.name = "Test Map";
	Points &b = a.points;
	size_t i;
	for(i = 0; i < 8; i++)
	{
		char name[] = "b";
		name[0] += i;
		b.push_back(Point(name, 320., 240.));
	}
	//#next i
	for(i = 0; i < 7; i++)
	{
		b[i].addConn(&(b[i+1]));
	}
	//#next i
	int addConn1 = randint(0,b.size()-1);
	int addConn2 = (addConn1 + randint(0,b.size())) % b.size();
	//cout << addConn1 << ", " << addConn2 << endl;
	if(addConn1 == addConn2)
	{
		//# Possible
		addConn2 = (addConn1 ^ 7) % b.size();
	}
	if(addConn1 == addConn2)
	{
		//# Unlikely
		addConn1 = 0;
	}
	if(addConn1 == addConn2)
	{
		//# Impossible
		addConn2 = b.size() - 1;
	}
	//#print b, addConn1, addConn2
	b[addConn1].addConn(&(b[addConn2]));
	for(i = 0; i < 4000; i++)
	{
		a.randomize();
		a.sort1();
		//#a.sort1()
		//#a.sort1()
		//#a.sort1()
		//#a.sort1()
	}
	//#next i
	return a;
}
//#end void createMap([seed_id])

int main(int argc, char **argv)
{
	Map m = createMap();
	cout << m.str() << endl;
}
//#end void main()

//if __name__ == '__main__':
//	main()
//#end if
