#!/usr/bin/env python3
"""
Swig interface to sww.cpp and friends.

time python3 -O test_sww_cpp.py
real    0m1.610s
user    0m1.607s
sys     0m0.002s
"""
import sww_cpp

def ConnList(x):
	r = []
	for j in x:
		k = sww_cpp.Conns()
		k.indices = sww_cpp.IntVector(j)
		r.append(k)
	#next j
	return sww_cpp.ConnListV(r)
#end def ConnList(x)

def main():
	# V_SmallWideWorld(float *x, ConnList *conns, float b0, LJ_Potential *lj_conf, ConnList *nonConns)
	x0 = sww_cpp.floatArray(100)
	for i in range(50):
		x0[2*i] = 40*(i)
		x0[(2*i)+1] = 0
	#next i
	print([x0[x] for x in range(100)])
	conns = ConnList([[2], [2], [0, 1]])
	b0 = 40.0
	lj_conf = sww_cpp.LJ_Potential()
	nonConns = ConnList([[1], [0], []])
	for i in range(1000000):
		Potential = sww_cpp.V_SmallWideWorld(x0, conns, b0, lj_conf, nonConns)
	#next i
	print(Potential)
#end def main()

if __name__ == '__main__':
	main()
#end if
