#!/usr/bin/env python
"""
friendmap2.py
by Javantea
June 4, 2007

Maps friends on Dodgeball
To get multiple levels, you have do this right. Seperation.
AddFriend needs a call that can be done properly in the middle of itself.
read the file to get a and a's friends.
todo urllib
"""
from __future__ import print_function
import urllib.request, urllib.error, urllib.parse
import re
from random import seed
import os
from time import sleep
from sys import path
path.append('.')
import mapmake1

# We use urlopen and file depending on protocol.
# http://www.dodgeball.com/user?uid=60145

class FriendMap(mapmake1.Map):
	def __init__(self, filename='data/dodge_jav1.html', seed_id = 234, level=0):
		seed(seed_id)
		# Width, height, line_width = 1, line_color=#9999ff.
		mapmake1.Map.__init__(self, None, 1000, 1000, 1, '#99cccc')
		self.p = []
		self.i = 0
		self.names = {}
		
		self.addFriend(filename, seed_id, level)
		self.organize()
	#def __init__(filename='dodge_jav1.html', seed_id = 234, levels=1)

	def addFriend(self, filename='data/dodge_jav1.html', seed_id = 234, level=0):
		data = open(filename, 'r').read()
		
		found_user = re.finditer(r'img src="([^"]+)" height="60" width="60" alt="([^"]+)"', data)
		
		found = re.finditer(r'\<a href="([^"]+)"\>\<img src="([^"]+)" height="60" width="60" alt="([^"]+)"', data)
		
		foaf_pos = None
		more_foafs = False
		foaf_fts = re.finditer(r'friends of friends', data)
		for found_ft in foaf_fts:
			if foaf_pos == None:
				foaf_pos = found_ft.start()
			else:
				more_foafs = True
			#end if
		#next found_ft
		
		if foaf_pos == None: foaf_pos = len(data)
		
		user = None
		friends = []
		foafs = []
		
		for img in found_user:
			user = img.groups()
			break
		#next img
		
		j = 0
		for friend in found:
			if j > 14: break
			# After the foaf title is full of friend of a friends (not useful for us)
			if friend.start() < foaf_pos:
				friends.append(friend.groups())
			else:
				foafs.append(friend.groups())
			j += 1
		#next friend
		
		"""print 'user =', user
		print 'friends =', friends
		print 'friend of a friends =', foafs
		if more_foafs: print "+ more friends of a friend."
		"""
	
		if user == None: return
	
		local_p = []
		
		# img = (img, name)
		if user[1] not in list(self.names.keys()):
			self.p.append(mapmake1.Point(user[1]))
			self.names[user[1]] = self.i
			user_pt = self.i
			local_p.append(self.p[user_pt])
			self.i += 1
		else:
			user_pt = self.names[user[1]]
			#print [str(a) for a in self.p], self.names
			#print 'user', user[1], user_pt, 'is in names', self.p[user_pt]
		#end if
		
		# friend = (url, img, name)
		for friend in friends:
			# Only add them if they are new.
			if friend[2] not in list(self.names.keys()):
				self.p.append(mapmake1.Point(friend[2], url='http://www.dodgeball.com' + friend[0], color='#9999cc'))
				self.names[friend[2]] = self.i
				local_p.append(self.p[self.i])
				self.i += 1
			#end if
			if level > 0:
				url = friend[0]
				b = re.search(r'([0-9]+)', url)
				friend_filename = 'data/dbu_' + str(b.groups()[0]) + '.html'
				if not os.path.exists(friend_filename):
					print('<!-- Grabbing', 'http://www.dodgeball.com' + url, '-->')
					# Need an absolute url.
					try:
						data = urllib.request.urlopen('http://www.dodgeball.com' + url).read()
						open(friend_filename, 'wb').write(data)
					except urllib.error.URLError as e:
						print('Warning: Could not grab dodgeball friend', url, ':', e)
						#skip over adding this friend's friends.
						continue
					#end try
					# Don't hit them very hard.
					sleep(1.0)
				#end if
				self.addFriend(friend_filename, seed_id, level - 1)
			#end if
		#next friend
		
		for friend in friends:
			fid = self.names[friend[2]]
			self.p[user_pt].addConn(self.p[fid])
			#print 'conn', self.p[user_pt], 'to', self.p[fid]
		#next friend
		
		self.addPoints(local_p)
	#end def addFriend([filename], [seed_id], levels)
	
	def sort2(self, dist1 = 170, f = 0.5):
		# We can override sort2 to do dist1 = 170 instead of 70.
		mapmake1.Map.sort2(self, dist1, f)
	#end def sort2(self, dist1 = 70, f = 0.5)
	
	def organize_old(self):
		self.randomize(600)
		for i in range(30):
			self.sort2()
			if i % 20 == 0:
				self.sort3()
			#end if
			if i % 15 == 0:
				self.randomize(300)
			#end if
			#a.sort1()
			#a.sort1()
			#a.sort1()
			#a.sort1()
		#next i
		#m.sort3()
		self.center()
	#def organize()
	
	def organize(self):
		f = 0.71
		scale = (self.width + self.height) / 2.0
		self.randomize(int(scale / (0.65*f)))
		for i in range(50):
			self.sort2(scale / (7.5*f), 0.7)
			if i % 30 == 0:
				self.sort3()
			#end if
			if i % 32 == 0:
				self.sort4()
			#end if
			if i % 25 == 0:
				self.randomize(int(scale / (10.0*f)))
			#end if
			#a.sort1()
			#a.sort1()
			#a.sort1()
			#a.sort1()
		#next i
		for i in range(12):
			self.sort4()
		#next i
		#m.sort3()
		self.center()
	#def organize()
	
	#def __str__(self):
	#	return str(self.m)
	#end def __str__()
#end class FriendMap

def main(seed_id = 2323):
	filename = 'data/dodge_jav1.html'
	from sys import argv
	if len(argv) > 1:
		filename = argv[1]
	#end if
	m = FriendMap(filename, seed_id, 1)
	print(m)
#end def main()

if __name__ == '__main__':
	main()
#end if
