#!/usr/bin/env python3
"""
Convert Small Wide World JSON to SVG
by Javantea
Jan 4, 2016
"""
from __future__ import print_function
import mapmake1

def JsonToSvg(jsonData, seed_id=222):
	mapmake1.seed(seed_id)
	map1 = mapmake1.Map()
	map1.loadJson(jsonData)
	return map1.drawSvg()
#end def JsonToSvg(jsonData, seed_id=222)

def main():
	import sys
	filename = None
	if (len (sys.argv) > 1):
		filename = sys.argv[1]
	#end if
	if not filename:
		print("Usage: json2svg.py filename.json > filename.svg")
		exit(1)
	#end if
	print(JsonToSvg(open(filename, 'r').read()), end='')
#end def main()

if __name__ == '__main__':
    main()
#end if
