#!/usr/bin/env python3
"""
Smallest loop 3 nodes equilateral triangle
{"nodes":[["a",400,263], ["b",367,319], ["c",433,319]], "conns":[["a","b"], ["a","c"], ["b","c"]]}

The main problem besides sortBranch acting stupidly is that we don't know quite what to do. Let's reorder the thing and see what happens. Wait a second, this looks the same no matter how you rotate it, so it shouldn't matter the order... So why doesn't it, oh I see. It's going left and right. A different graph would look different. Let's look at that.

Almost correct rendering the 4 node variant of the triangle.
{"nodes":[["a",407,300], ["b",374,319], ["c",375,280], ["d",444,301]], "conns":[["a","b"], ["a","c"], ["a","d"], ["b","c"]]}

Let's just go right to the whole N-gon now because we can.
"""
import mapmake1

def nameIncremental2(i):
	"""
	a b c ... aa ab ac ad ae ... ba bb bc bd ... ca cb cc ...
	aaa aab aac aad ... baa bab bac bad ...
	aaaa aaab aaac aaad ... baaa baab baac baad ....
	"""
	if i == 0: return 'a'
	alphabet = 'abcdefghijklmnopqrstuvwxyz'
	output = ''
	#verbose = False
	#if i >= 26*26: verbose = True
	p = i
	digit = 0
	while i > 0:
		#if verbose: print('i in', i)
		i, p = divmod(i, 26)
		if digit > 0: p -= 1
		#if verbose: print('i, p out', i, p)
		output = alphabet[p] + output
		if p < 0:
			if i == 1: break
			i -= 1
		#end if
		digit += 1
	#loop
	#output = alphabet[p] + output
	#if verbose: print('output', output)
	return output
#end def nameIncremental2(i)


def makeNgon(nodes=3, seed_id=3333):
	"""
	
	"""
	mapmake1.seed(seed_id)
	a = mapmake1.Map()
	b = []
	for i in range(nodes):
		b.append(mapmake1.Point(nameIncremental2(i)))

	for i in range(nodes-1):
		b[i].addConn(b[i+1])

	b[-1].addConn(b[0])
	a.addPoints(b)
	a.sortLoop()
	a.centerBound()
	return a
#end def makeNgon(nodes=3, seed_id=3333)

def main():
	for i in range(3, 40):
		a = makeNgon(i)
		open('%igon.json' % i, 'w').write(a.saveJson())
	#next i
#end def main()

if __name__ == '__main__':
	main()
#end if
