#!/usr/bin/env python3
"""
Grid1 Minimized Test Parser
by Javantea
May 8, 2016

for file in grid1[j-p]/*.txt; do python3 parsegridm1.py "$file" >"${file%.txt}".dat; done
cat grid1[j-p]/*.dat >grid1jp.dat
"""
import sys

def main():
	"""
	Parse and print output from grid1.py -m -t
	"""
	filename = 'grid1j/grid1testx38.txt'
	if len(sys.argv) > 1:
		filename = sys.argv[1]
	#end if
	a = open(filename, 'r').read().split('\n')

	data = []
	newMap = None
	seed = None
	newSeed = None
	for line in a:
		if line.startswith('Map: '):
			x = line.split(' ')
			if newMap and len(newMap) > 3:
				# Seed comes first but we want it last.
				data.append(newMap + [seed])
			#end if
			newMap = x[1:]
		elif line.startswith('Branch dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Branch Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Grid dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Grid Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Spiral dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Spiral Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Lattice dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Lattice Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Linear dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Linear Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Loop dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Loop Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Right Sort dt: '):
			x = line.split(' ')
			newMap.append(x[3])
		elif line.startswith('Right Sort Potential: '):
			x = line.split(' ')
			newMap.append(x[3])
		elif line.startswith('Right Loop dt: '):
			x = line.split(' ')
			newMap.append(x[3])
		elif line.startswith('Right Loop Potential: '):
			x = line.split(' ')
			newMap.append(x[3])
		elif line.startswith('Random dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Random Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('FruchtermanReingold dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('FruchtermanReingold Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Metropolis dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Metropolis Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Metropolis(0.2s) dt: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('Metropolis(0.2s) Potential: '):
			x = line.split(' ')
			newMap.append(x[2])
		elif line.startswith('seed: '):
			x = line.split(' ')
			# Need to keep the old value because of order.
			seed = newSeed
			newSeed = x[1]
		#end if
	#next line

	if newMap and len(newMap) > 3:
		data.append(newMap + [newSeed])
	#end if

	for row in data:
		print(' '.join(row))
	#next row
#end def main()

if __name__ == '__main__':
	main()
#end if
