/*
 * Polar Coordinates
 * by Javantea
 * Jan 25, 2016
 * Based on polar1.py Polar Coordinates
 * by Javantea
 * Nov 10, 2015
 * Based on AltSci Algorithm Spherical Coordinates Take 2
 * by Javantea
 * Oct 26, 2014
 *
 */
SMALL = 1e-12;
SMALL_SQ = 1e-24;

/*
 * cartesianToPolar(v)
	Input vector (x, y)
	Output vector (r, theta)
	r = |v|
	phi = atan2(y, x)
 */
function cartesianToPolar(v)
{
	if (v instanceof Array) {
		x = v[0];
		y = v[1];
	} else {
		x = v.x;
		y = v.y;
	}
	//# r = |v|
	r = Math.sqrt(x*x + y*y);

	//# Fixed!
	theta = Math.atan2(y, x);
	
	return [r, theta];
} //#end def cartesianToPolar(v)

/*
 * cartesianToPolar(v)
	Input vector (r, theta)
	Output vector (x, y)
	See cartesianToPolar for formulae or the source.
 */ 
function polarToCartesian(v)
{
	r = v[0];
	theta = v[1];
	x = r * Math.cos(theta);
	y = r * Math.sin(theta);
	//#print('ptc %3.3f %3.3f' % (x, y))
	return [x, y];
} //#end def polarToCartesian(v)

/*
 * polar_sub(v1, v2)
	NOTE: Don't use this function, use cartesian coordinates from the get 
	go, then convert to polar.
 */
function polar_sub(v1, v2)
{
	var vc1 = polarToCartesian(v1);
	var vc2 = polarToCartesian(v2);
	return cartesianToPolar((vc1[0]-vc2[0], vc1[1]-vc2[1]));
} //#end def polar_sub(v1, v2)

/*
 * polar_add(v1, v2)
	NOTE: Don't use this function, use cartesian coordinates from the get 
	go, then convert to polar.
 */
function polar_add(v1, v2)
{
	var vc1 = polarToCartesian(v1);
	var vc2 = polarToCartesian(v2);
	return cartesianToPolar((vc1[0]+vc2[0], vc1[1]+vc2[1]));
} //#end def polar_add(v1, v2)
