"""
rsvg-rmap2.py
by Javantea
June 27, 2007

Draw route maps with rsvg.
This cool library can easily draw any svg from file or memory.
This is the proper way to make dynamic, editable svg systems in Python.
Eventually this frame will be used to create many cool projects such as AltSci 
Composer.

"""

from sys import path, argv, hexversion
#path.append('./c4s')
if hexversion > 0x3000000:
	from rsvg_map3 import DisplaySVG, Gtk, Gdk
	Python2 = False
	Python3 = True
else:
	from rsvg_map2 import DisplaySVG, gtk
	Python2 = True
	Python3 = False
#end if

def main():
	import routemap1
	seed = '222'
	filename = 'output/traceroute1_mmNASc.txt'
	if (len (argv) > 1):
		filename = argv[1]
	#end if
	a = DisplaySVG('rsvg Route Map Renderer in Python', routemap1.createRouteMap, (filename, seed))
	if Python3:
		Gdk.threads_init()
		Gtk.main()
	else:
		gtk.gdk.threads_init()
		gtk.main()
	#end if
#end def main()

if __name__ == '__main__':
    main()
#end if
