#!/usr/bin/env python3
"""
Split Stress Test

One of the interesting functions that hasn't been explored enough that I thought about today is Map.split()
I suppose to test it I should create a 4000 node graph (ridiculously large) from 20 independent graphs. Then running split ought to give me 20 graphs.
But before 4000 nodes, let's do 2 graphs of 200 nodes to save time.

"""

import sww_optimize1
import mapmake1

map1 = sww_optimize1.createMap4(192, 14, 8)
#sortBranch in 0.164246321 seconds

map2 = sww_optimize1.createMap4(192, 14, 8, 9919191)
#sortBranch in 0.121670008 seconds

# Combine the two maps
max2_y = max([p.y for p in map2.points]) + 10
map3 = mapmake1.Map()
map3.addPoints([mapmake1.Point('map1_'+p.name, None, p.x, p.y+max2_y) for p in map1.points])
map3.addPoints([mapmake1.Point('map2_'+p.name, None, p.x, p.y) for p in map2.points])
# Save the map
#open('split_stress1.json','w').write(map3.saveJson())

map1point_name = {}
for p in map1.points:
    map1point_name[p.name] = p

map2point_name = {}
for p in map2.points:
    map2point_name[p.name] = p

map3point_name = {}
for p in map3.points:
    map3point_name[p.name] = p

for p in map3.points:
    if p.name[:4] == 'map1':
        q = map1point_name[p.name[5:]]
        for x in q.conns:
            p.addConn(map3point_name['map1_' + x.name])
    else:
        q = map2point_name[p.name[5:]]
        for x in q.conns:
            p.addConn(map3point_name['map2_' + x.name])

two = map3.split()
print(len(two), [len(x) for x in two])
#print([(map3.points.index(x), str(x)) for x in two[1]])
