// SWW structure
var sww = null;
var confirmClear = true;
var renderText = false;
var displayo = null;
var displaydiv = null;

function swwRenderOne(svg, mapJson)
{
	displayo = svg;
	displaydiv = svg.parentNode;
	window.onload = function() { r(mapJson); 
		Display().onmousemove = OnMouseMove;
		Display().onmousedown = OnMouseDown;
		Display().onmouseup = OnMouseUp;
	};
}

// Get the display element.
function Display()
{
	return displayo; //document.getElementById('ndisplay');
}

function htmlentities(st)
{
	// Note, /g is required or else it only replaces the first instance. XSS.
	// FIXME: This is important, unencodable utf-8 needs to be escaped.
	return st.replace(/"/g, '&quot;').replace(/>/g, '&gt;').replace(/</g, '&lt;');
}

function displayClear()
{
	// Dimensions of drawing area.
	var dims = Dimensions();
	sww = new Map([], dims.w, dims.h);
	var disp = Display();
	while(disp.hasChildNodes())
	{
		disp.removeChild(disp.childNodes[0]);
	}
	update();
}

function debug(st)
{
	console.log(st);
}

// Determine dimensions of the display element.
// Return this as a 2-tuple (x,y) in an array
function Dimensions()
{
	// Our Rendering Element
	var display = Display();
	var width = parseInt( display.getAttributeNS(null,'width') );
	var height = parseInt( display.getAttributeNS(null,'height') );

	return {'w':width,'h':height};
}

// This is called by mouse move events
var mouse_x = 200, mouse_y = 150;
var dragging = false;
var currentNode = -1;
var connecting = false;
function OnMouseMove(evt)
{
	var canvas = displaydiv; //document.getElementById('ndispbox');
	mouse_x = evt.clientX;
	mouse_y = evt.clientY;
	mouse_x -= canvas.offsetLeft;
	mouse_y -= canvas.offsetTop;
	mouse_x += window.scrollX;
	mouse_y += window.scrollY;
	//debug(canvas.offsetLeft + " " + canvas.offsetTop);
	if(dragging) dragNode();
}
function OnMouseDown(evt)
{
	if(!connecting) dragging = true;
	currentNode = nearestNode();
	//debug("cn " + currentNode);
}
function OnMouseUp(evt)
{
	dragging = false;
	if(connecting)
	{
		// Connect the two nodes.
		toConnectNode = nearestNode();
		//debug("Connecting " + currentNode + " " + toConnectNode);
		if(currentNode != toConnectNode)
		{
			sww.points[currentNode].addConn(sww.points[toConnectNode]);
		}
		update();
	}
	currentNode = -1;
}

function update()
{
	// First call?
	if( !sww ) {
		// Dimensions of drawing area.
		var dims = Dimensions();
		sww = new Map([], dims.w, dims.h);
	}
	
	var display = Display();
	var i;
	for(i = 0; i < sww.points.length; i++)
	{
		sww.points[i].draw(display);
		if(renderText) {
			sww.points[i].text.style.display='';
		} else {
			sww.points[i].text.style.display='none';
		}
	}
}

function nearestNode()
{
	var bestNode = -1;
	var dist = null;
	for(i = 0; i < sww.points.length; i++)
	{
		var d = Math.sqrt(Math.pow(mouse_x-sww.points[i].x, 2) + Math.pow(mouse_y-sww.points[i].y, 2));
		if(bestNode < 0 || d < dist)
		{
			dist = d;
			bestNode = i;
			// Just grab it if it's this close.
			if(d < 3) break;
		}
	}
	return bestNode;
}

function dragNode()
{
	// FIXME: scroll and offset of the window from the viewport.
	if(currentNode == -1) return;
	sww.points[currentNode].x = mouse_x;
	sww.points[currentNode].y = mouse_y;
	update();
}

function saveSvg()
{
	var disp = Display();
	debug(disp.outerHTML);
}

function saveDot()
{
	debug("Apologies, the dot format is not currently written. Send a patch. Use the source.");
}
/*
	* save JSON output
	* Difficult because of the design, but it works in JavaScript and Python, likely others.
	* 
	*/
function saveJson()
{
	debug(sww.saveJson());
}

function r(x)
{ 
	displayClear(); 
	var dims = Dimensions();
	sww = new Map([], dims.w, dims.h);
	loadJsonObj(x);
	update();
}

/*
	* loadJsonObj(jsobj)
	* Take an object and load it into the graph.
	* Object jsobj looks like: 
	* {"nodes":[["node 0", 233, 224], ["node 1", 407, 118]], "conns":[["node 0", "node 1"]]}
	*/
function loadJsonObj(jsobj)
{
	sww.loadJson(jsobj);
}
